split obj dir into separate release and debug dirs
[platform/upstream/flac.git] / test / test_bins.sh
1 #!/bin/sh
2
3 #  FLAC - Free Lossless Audio Codec
4 #  Copyright (C) 2001,2002  Josh Coalson
5 #
6 #  This program is part of FLAC; you can redistribute it and/or
7 #  modify it under the terms of the GNU General Public License
8 #  as published by the Free Software Foundation; either version 2
9 #  of the License, or (at your option) any later version.
10 #
11 #  This program is distributed in the hope that it will be useful,
12 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
13 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14 #  GNU General Public License for more details.
15 #
16 #  You should have received a copy of the GNU General Public License
17 #  along with this program; if not, write to the Free Software
18 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
19
20 LD_LIBRARY_PATH=../src/libFLAC/.libs:../obj/release/lib:../obj/debug/lib:$LD_LIBRARY_PATH
21 export LD_LIBRARY_PATH
22 PATH=../src/flac:../obj/release/b:../obj/debug/bin:$PATH
23 BINS_PATH=../../test_files/bins
24
25 flac --help 1>/dev/null 2>/dev/null || (echo "ERROR can't find flac executable" 1>&2 && exit 1)
26 if [ $? != 0 ] ; then exit 1 ; fi
27
28 #FLAC="valgrind --leak-check=yes --show-reachable=yes --logfile-fd=1 flac"
29 FLAC=flac
30
31 test -d ${BINS_PATH} || exit 77
32
33 test_file ()
34 {
35         name=$1
36         channels=$2
37         bps=$3
38         encode_options="$4"
39
40         echo -n "$name (--channels=$channels --bps=$bps $encode_options): encode..."
41         cmd="$FLAC --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options $name.bin"
42         echo "### ENCODE $name #######################################################" >> ./streams.log
43         echo "###    cmd=$cmd" >> ./streams.log
44         if $cmd 2>>./streams.log ; then : ; else
45                 echo "ERROR during encode of $name" 1>&2
46                 exit 1
47         fi
48         echo -n "decode..."
49         cmd="$FLAC --silent --endian=big --sign=signed --decode --force-raw-format $name.flac";
50         echo "### DECODE $name #######################################################" >> ./streams.log
51         echo "###    cmd=$cmd" >> ./streams.log
52         if $cmd 2>>./streams.log ; then : ; else
53                 echo "ERROR during decode of $name" 1>&2
54                 exit 1
55         fi
56         ls -1l $name.bin >> ./streams.log
57         ls -1l $name.flac >> ./streams.log
58         ls -1l $name.raw >> ./streams.log
59         echo -n "compare..."
60         if cmp $name.bin $name.raw ; then : ; else
61                 echo "ERROR during compare of $name" 1>&2
62                 exit 1
63         fi
64         echo OK
65 }
66
67 echo "Testing bins..."
68 for f in b00 b01 b02 b03 b04 ; do
69         binfile=$BINS_PATH/$f
70         if [ -f $binfile ] ; then
71                 for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do
72                         for channels in 1 2 4 8 ; do
73                                 for bps in 8 16 24 ; do
74                                         for opt in 0 1 2 4 5 6 8 ; do
75                                                 for extras in '' '-p' '-e' ; do
76                                                         for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do
77                                                                 test_file $binfile $channels $bps "-$opt $extras $blocksize $disable"
78                                                         done
79                                                 done
80                                         done
81                                         if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
82                                                 test_file $binfile $channels $bps "-b 16384 -m -r 8 -l 32 -e -p $disable"
83                                         fi
84                                 done
85                         done
86                 done
87         else
88                 echo "$binfile not found, skipping."
89         fi
90 done